"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = exports.ServerConfig = exports.ServerMapConfig = exports.EmailConfig = exports.InternalConfig = exports.LoggingConfig = exports.UsersConfig = void 0;
const sparkson_1 = require("sparkson");
const shared_1 = require("./shared");
let UsersConfig = class UsersConfig {
    constructor(username, passwordHash) {
        this.username = username;
        this.passwordHash = passwordHash;
    }
};
UsersConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("user")),
    __param(1, (0, sparkson_1.Field)("passwordHash")),
    __metadata("design:paramtypes", [String, String])
], UsersConfig);
exports.UsersConfig = UsersConfig;
let LoggingConfig = class LoggingConfig {
    constructor(enabled, debug, profile) {
        this.enabled = enabled;
        this.debug = debug;
        this.profile = profile;
    }
};
LoggingConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("enabled")),
    __param(1, (0, sparkson_1.Field)("debug")),
    __param(2, (0, sparkson_1.Field)("profile")),
    __metadata("design:paramtypes", [Boolean, Boolean, Boolean])
], LoggingConfig);
exports.LoggingConfig = LoggingConfig;
let InternalConfig = class InternalConfig {
    constructor(active, users) {
        this.active = active;
        this.users = users;
    }
};
InternalConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("active")),
    __param(1, (0, sparkson_1.ArrayField)("users", UsersConfig)),
    __metadata("design:paramtypes", [Boolean, Array])
], InternalConfig);
exports.InternalConfig = InternalConfig;
let EmailConfig = class EmailConfig {
    constructor(from, 
    // For details see: https://nodemailer.com/2-0-0-beta/setup-smtp/
    smtp) {
        this.from = from;
        this.smtp = smtp;
    }
};
EmailConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("from")),
    __param(1, (0, sparkson_1.RawJsonField)("smtp")),
    __metadata("design:paramtypes", [String, Object])
], EmailConfig);
exports.EmailConfig = EmailConfig;
let ServerMapConfig = class ServerMapConfig {
    constructor(nodesJsonUrl) {
        this.nodesJsonUrl = nodesJsonUrl;
    }
};
ServerMapConfig = __decorate([
    __param(0, (0, sparkson_1.ArrayField)("nodesJsonUrl", String)),
    __metadata("design:paramtypes", [Array])
], ServerMapConfig);
exports.ServerMapConfig = ServerMapConfig;
let ServerConfig = class ServerConfig {
    constructor(baseUrl, port, databaseFile, peersPath, logging, internal, email, map, rootPath) {
        this.baseUrl = baseUrl;
        this.port = port;
        this.databaseFile = databaseFile;
        this.peersPath = peersPath;
        this.logging = logging;
        this.internal = internal;
        this.email = email;
        this.map = map;
        this.rootPath = rootPath;
    }
};
ServerConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("baseUrl")),
    __param(1, (0, sparkson_1.Field)("port")),
    __param(2, (0, sparkson_1.Field)("databaseFile")),
    __param(3, (0, sparkson_1.Field)("peersPath")),
    __param(4, (0, sparkson_1.Field)("logging")),
    __param(5, (0, sparkson_1.Field)("internal")),
    __param(6, (0, sparkson_1.Field)("email")),
    __param(7, (0, sparkson_1.Field)("map")),
    __param(8, (0, sparkson_1.Field)("rootPath", true, undefined, "/")),
    __metadata("design:paramtypes", [String, Number, String, String, LoggingConfig,
        InternalConfig,
        EmailConfig,
        ServerMapConfig, String])
], ServerConfig);
exports.ServerConfig = ServerConfig;
let Config = class Config {
    constructor(server, client) {
        this.server = server;
        this.client = client;
    }
};
Config = __decorate([
    __param(0, (0, sparkson_1.Field)("server")),
    __param(1, (0, sparkson_1.Field)("client")),
    __metadata("design:paramtypes", [ServerConfig,
        shared_1.ClientConfig])
], Config);
exports.Config = Config;
//# sourceMappingURL=config.js.map