"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMailSortField = exports.MailSortField = exports.isTaskSortField = exports.TaskSortField = exports.isMonitoringSortField = exports.MonitoringSortField = exports.isNodesFilter = exports.NODES_FILTER_FIELDS = exports.isNodeSortField = exports.NodeSortField = exports.isEnhancedNode = exports.isDomain = exports.isSite = exports.isOnlineState = exports.OnlineState = exports.isNode = exports.isNodeId = exports.isMonitoringState = exports.MonitoringState = exports.isMAC = exports.isFastdKey = exports.isToken = exports.isClientConfig = exports.ClientConfig = exports.isOtherCommunityInfoConfig = exports.OtherCommunityInfoConfig = exports.isCoordsSelectorConfig = exports.CoordsSelectorConfig = exports.isCoords = exports.Coords = exports.isMonitoringConfig = exports.MonitoringConfig = exports.isClientMapConfig = exports.ClientMapConfig = exports.isLegalConfig = exports.LegalConfig = exports.isCommunityConfig = exports.CommunityConfig = exports.isStatistics = exports.isNodeStatistics = exports.isVersion = exports.isOptional = exports.toIsEnum = exports.toIsArray = exports.isBoolean = exports.isNumber = exports.isString = exports.isMap = exports.isArray = exports.isObject = void 0;
exports.isSortDirection = exports.SortDirection = void 0;
const sparkson_1 = require("sparkson");
function isObject(arg) {
    return arg !== null && typeof arg === "object";
}
exports.isObject = isObject;
function isArray(arg, isT) {
    if (!Array.isArray(arg)) {
        return false;
    }
    for (const element of arg) {
        if (!isT(element)) {
            return false;
        }
    }
    return true;
}
exports.isArray = isArray;
function isMap(arg) {
    return arg instanceof Map;
}
exports.isMap = isMap;
function isString(arg) {
    return typeof arg === "string";
}
exports.isString = isString;
function isNumber(arg) {
    return typeof arg === "number";
}
exports.isNumber = isNumber;
function isBoolean(arg) {
    return typeof arg === "boolean";
}
exports.isBoolean = isBoolean;
function toIsArray(isT) {
    return (arg) => isArray(arg, isT);
}
exports.toIsArray = toIsArray;
function toIsEnum(enumDef) {
    return (arg) => Object.values(enumDef).includes(arg);
}
exports.toIsEnum = toIsEnum;
function isOptional(arg, isT) {
    return arg === undefined || isT(arg);
}
exports.isOptional = isOptional;
// Should be good enough for now.
exports.isVersion = isString;
function isNodeStatistics(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const stats = arg;
    return (isNumber(stats.registered) &&
        isNumber(stats.withVPN) &&
        isNumber(stats.withCoords) &&
        isObject(stats.monitoring) &&
        isNumber(stats.monitoring.active) &&
        isNumber(stats.monitoring.pending));
}
exports.isNodeStatistics = isNodeStatistics;
function isStatistics(arg) {
    return isObject(arg) && isNodeStatistics(arg.nodes);
}
exports.isStatistics = isStatistics;
let CommunityConfig = class CommunityConfig {
    constructor(name, domain, contactEmail, sites, domains) {
        this.name = name;
        this.domain = domain;
        this.contactEmail = contactEmail;
        this.sites = sites;
        this.domains = domains;
    }
};
CommunityConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("name")),
    __param(1, (0, sparkson_1.Field)("domain")),
    __param(2, (0, sparkson_1.Field)("contactEmail")),
    __param(3, (0, sparkson_1.ArrayField)("sites", String)),
    __param(4, (0, sparkson_1.ArrayField)("domains", String)),
    __metadata("design:paramtypes", [String, String, String, Array, Array])
], CommunityConfig);
exports.CommunityConfig = CommunityConfig;
function isCommunityConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return (isString(cfg.name) &&
        isString(cfg.domain) &&
        isString(cfg.contactEmail) &&
        isArray(cfg.sites, isString) &&
        isArray(cfg.domains, isString));
}
exports.isCommunityConfig = isCommunityConfig;
let LegalConfig = class LegalConfig {
    constructor(privacyUrl, imprintUrl) {
        this.privacyUrl = privacyUrl;
        this.imprintUrl = imprintUrl;
    }
};
LegalConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("privacyUrl", true)),
    __param(1, (0, sparkson_1.Field)("imprintUrl", true)),
    __metadata("design:paramtypes", [String, String])
], LegalConfig);
exports.LegalConfig = LegalConfig;
function isLegalConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return (isOptional(cfg.privacyUrl, isString) &&
        isOptional(cfg.imprintUrl, isString));
}
exports.isLegalConfig = isLegalConfig;
let ClientMapConfig = class ClientMapConfig {
    constructor(mapUrl) {
        this.mapUrl = mapUrl;
    }
};
ClientMapConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("mapUrl")),
    __metadata("design:paramtypes", [String])
], ClientMapConfig);
exports.ClientMapConfig = ClientMapConfig;
function isClientMapConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return isString(cfg.mapUrl);
}
exports.isClientMapConfig = isClientMapConfig;
let MonitoringConfig = class MonitoringConfig {
    constructor(enabled) {
        this.enabled = enabled;
    }
};
MonitoringConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("enabled")),
    __metadata("design:paramtypes", [Boolean])
], MonitoringConfig);
exports.MonitoringConfig = MonitoringConfig;
function isMonitoringConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return isBoolean(cfg.enabled);
}
exports.isMonitoringConfig = isMonitoringConfig;
let Coords = class Coords {
    constructor(lat, lng) {
        this.lat = lat;
        this.lng = lng;
    }
};
Coords = __decorate([
    __param(0, (0, sparkson_1.Field)("lat")),
    __param(1, (0, sparkson_1.Field)("lng")),
    __metadata("design:paramtypes", [Number, Number])
], Coords);
exports.Coords = Coords;
function isCoords(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const coords = arg;
    return (isNumber(coords.lat) &&
        isNumber(coords.lng));
}
exports.isCoords = isCoords;
let CoordsSelectorConfig = class CoordsSelectorConfig {
    constructor(lat, lng, defaultZoom, layers) {
        this.lat = lat;
        this.lng = lng;
        this.defaultZoom = defaultZoom;
        this.layers = layers;
    }
};
CoordsSelectorConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("lat")),
    __param(1, (0, sparkson_1.Field)("lng")),
    __param(2, (0, sparkson_1.Field)("defaultZoom")),
    __param(3, (0, sparkson_1.RawJsonField)("layers")),
    __metadata("design:paramtypes", [Number, Number, Number, Object])
], CoordsSelectorConfig);
exports.CoordsSelectorConfig = CoordsSelectorConfig;
function isCoordsSelectorConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return (isNumber(cfg.lat) &&
        isNumber(cfg.lng) &&
        isNumber(cfg.defaultZoom) &&
        isObject(cfg.layers) // TODO: Better types!
    );
}
exports.isCoordsSelectorConfig = isCoordsSelectorConfig;
let OtherCommunityInfoConfig = class OtherCommunityInfoConfig {
    constructor(showInfo, showBorderForDebugging, localCommunityPolygon) {
        this.showInfo = showInfo;
        this.showBorderForDebugging = showBorderForDebugging;
        this.localCommunityPolygon = localCommunityPolygon;
    }
};
OtherCommunityInfoConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("showInfo")),
    __param(1, (0, sparkson_1.Field)("showBorderForDebugging")),
    __param(2, (0, sparkson_1.ArrayField)("localCommunityPolygon", Coords)),
    __metadata("design:paramtypes", [Boolean, Boolean, Array])
], OtherCommunityInfoConfig);
exports.OtherCommunityInfoConfig = OtherCommunityInfoConfig;
function isOtherCommunityInfoConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return (isBoolean(cfg.showInfo) &&
        isBoolean(cfg.showBorderForDebugging) &&
        isArray(cfg.localCommunityPolygon, isCoords));
}
exports.isOtherCommunityInfoConfig = isOtherCommunityInfoConfig;
let ClientConfig = class ClientConfig {
    constructor(community, legal, map, monitoring, coordsSelector, otherCommunityInfo, rootPath) {
        this.community = community;
        this.legal = legal;
        this.map = map;
        this.monitoring = monitoring;
        this.coordsSelector = coordsSelector;
        this.otherCommunityInfo = otherCommunityInfo;
        this.rootPath = rootPath;
    }
};
ClientConfig = __decorate([
    __param(0, (0, sparkson_1.Field)("community")),
    __param(1, (0, sparkson_1.Field)("legal")),
    __param(2, (0, sparkson_1.Field)("map")),
    __param(3, (0, sparkson_1.Field)("monitoring")),
    __param(4, (0, sparkson_1.Field)("coordsSelector")),
    __param(5, (0, sparkson_1.Field)("otherCommunityInfo")),
    __param(6, (0, sparkson_1.Field)("rootPath", true, undefined, "/")),
    __metadata("design:paramtypes", [CommunityConfig,
        LegalConfig,
        ClientMapConfig,
        MonitoringConfig,
        CoordsSelectorConfig,
        OtherCommunityInfoConfig, String])
], ClientConfig);
exports.ClientConfig = ClientConfig;
function isClientConfig(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const cfg = arg;
    return (isCommunityConfig(cfg.community) &&
        isLegalConfig(cfg.legal) &&
        isClientMapConfig(cfg.map) &&
        isMonitoringConfig(cfg.monitoring) &&
        isCoordsSelectorConfig(cfg.coordsSelector) &&
        isOtherCommunityInfoConfig(cfg.otherCommunityInfo) &&
        isString(cfg.rootPath));
}
exports.isClientConfig = isClientConfig;
exports.isToken = isString;
exports.isFastdKey = isString;
exports.isMAC = isString;
var MonitoringState;
(function (MonitoringState) {
    MonitoringState["ACTIVE"] = "active";
    MonitoringState["PENDING"] = "pending";
    MonitoringState["DISABLED"] = "disabled";
})(MonitoringState = exports.MonitoringState || (exports.MonitoringState = {}));
exports.isMonitoringState = toIsEnum(MonitoringState);
exports.isNodeId = isString;
function isNode(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const node = arg;
    return ((0, exports.isToken)(node.token) &&
        isString(node.nickname) &&
        isString(node.email) &&
        isString(node.hostname) &&
        isOptional(node.coords, isString) &&
        isOptional(node.key, exports.isFastdKey) &&
        (0, exports.isMAC)(node.mac) &&
        isBoolean(node.monitoring) &&
        isBoolean(node.monitoringConfirmed) &&
        (0, exports.isMonitoringState)(node.monitoringState) &&
        isNumber(node.modifiedAt));
}
exports.isNode = isNode;
var OnlineState;
(function (OnlineState) {
    OnlineState["ONLINE"] = "ONLINE";
    OnlineState["OFFLINE"] = "OFFLINE";
})(OnlineState = exports.OnlineState || (exports.OnlineState = {}));
exports.isOnlineState = toIsEnum(OnlineState);
exports.isSite = isString;
exports.isDomain = isString;
function isEnhancedNode(arg) {
    if (!isNode(arg)) {
        return false;
    }
    const node = arg;
    return (isOptional(node.site, exports.isSite) &&
        isOptional(node.domain, exports.isDomain) &&
        isOptional(node.onlineState, exports.isOnlineState));
}
exports.isEnhancedNode = isEnhancedNode;
var NodeSortField;
(function (NodeSortField) {
    NodeSortField["HOSTNAME"] = "hostname";
    NodeSortField["NICKNAME"] = "nickname";
    NodeSortField["EMAIL"] = "email";
    NodeSortField["TOKEN"] = "token";
    NodeSortField["MAC"] = "mac";
    NodeSortField["KEY"] = "key";
    NodeSortField["SITE"] = "site";
    NodeSortField["DOMAIN"] = "domain";
    NodeSortField["COORDS"] = "coords";
    NodeSortField["ONLINE_STATE"] = "onlineState";
    NodeSortField["MONITORING_STATE"] = "monitoringState";
})(NodeSortField = exports.NodeSortField || (exports.NodeSortField = {}));
exports.isNodeSortField = toIsEnum(NodeSortField);
exports.NODES_FILTER_FIELDS = {
    hasKey: Boolean,
    hasCoords: Boolean,
    monitoringState: MonitoringState,
    site: String,
    domain: String,
    onlineState: OnlineState,
};
function isNodesFilter(arg) {
    if (!isObject(arg)) {
        return false;
    }
    const filter = arg;
    return (isOptional(filter.hasKey, isBoolean) &&
        isOptional(filter.hasCoords, isBoolean) &&
        isOptional(filter.monitoringState, exports.isMonitoringState) &&
        isOptional(filter.site, exports.isSite) &&
        isOptional(filter.domain, exports.isDomain) &&
        isOptional(filter.onlineState, exports.isOnlineState));
}
exports.isNodesFilter = isNodesFilter;
var MonitoringSortField;
(function (MonitoringSortField) {
    MonitoringSortField["ID"] = "id";
    MonitoringSortField["HOSTNAME"] = "hostname";
    MonitoringSortField["MAC"] = "mac";
    MonitoringSortField["SITE"] = "site";
    MonitoringSortField["DOMAIN"] = "domain";
    MonitoringSortField["MONITORING_STATE"] = "monitoring_state";
    MonitoringSortField["STATE"] = "state";
    MonitoringSortField["LAST_SEEN"] = "last_seen";
    MonitoringSortField["IMPORT_TIMESTAMP"] = "import_timestamp";
    MonitoringSortField["LAST_STATUS_MAIL_TYPE"] = "last_status_mail_type";
    MonitoringSortField["LAST_STATUS_MAIL_SENT"] = "last_status_mail_sent";
    MonitoringSortField["CREATED_AT"] = "created_at";
    MonitoringSortField["MODIFIED_AT"] = "modified_at";
})(MonitoringSortField = exports.MonitoringSortField || (exports.MonitoringSortField = {}));
exports.isMonitoringSortField = toIsEnum(MonitoringSortField);
var TaskSortField;
(function (TaskSortField) {
    TaskSortField["ID"] = "id";
    TaskSortField["NAME"] = "name";
    TaskSortField["SCHEDULE"] = "schedule";
    TaskSortField["STATE"] = "state";
    TaskSortField["RUNNING_SINCE"] = "runningSince";
    TaskSortField["LAST_RUN_STARTED"] = "lastRunStarted";
})(TaskSortField = exports.TaskSortField || (exports.TaskSortField = {}));
exports.isTaskSortField = toIsEnum(TaskSortField);
var MailSortField;
(function (MailSortField) {
    MailSortField["ID"] = "id";
    MailSortField["FAILURES"] = "failures";
    MailSortField["SENDER"] = "sender";
    MailSortField["RECIPIENT"] = "recipient";
    MailSortField["EMAIL"] = "email";
    MailSortField["CREATED_AT"] = "created_at";
    MailSortField["MODIFIED_AT"] = "modified_at";
})(MailSortField = exports.MailSortField || (exports.MailSortField = {}));
exports.isMailSortField = toIsEnum(MailSortField);
var SortDirection;
(function (SortDirection) {
    SortDirection["ASCENDING"] = "ASC";
    SortDirection["DESCENDING"] = "DESC";
})(SortDirection = exports.SortDirection || (exports.SortDirection = {}));
exports.isSortDirection = toIsEnum(SortDirection);
//# sourceMappingURL=shared.js.map